<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN">

<?php
	if (file_exists("config.php")) {
		include "config.php";
	} else {
		echo "<html><body>\n";
		echo "<p>Missing <b>config.php!</b></p><p>Copy <b>config.sample.php</b> to <b>config.php</b> and edit.</p>\n";
		echo "</body></html>\n";
		exit;
	}
?>

<html>
<head>
<title>Check status and calibrate hardware daemon</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link href="temp.css" type="text/css" rel="stylesheet">
<meta http-equiv="Pragma" content="no-cache">

<style type="text/css">
pre {
  	background-color: #F8F8F8;
	font-family: Fixed, monospace; 
	font-size:small;
	margin-left:10px;
#	margin-right:10px;
}

#pre { 
  	background-color: #F8F8F8;
	border:1px dashed; 
	width:95%; 
}

.textarea_digital { font-family:"Digital-7"; 
					white-space: nowrap; 
					display:inline-block; 
					font-size: 30px;
					color:green;
					height: 28px;
}
</style>

</head>

<body>
<h1>Check status and calibrate hardware daemon</h1>

<?php
	if( !isset($daemon_host) || !isset($daemon_port)) {
		echo "<p>Error, daemon_host or daemon_port not set!</b>\n";
		echo "</body>\n</html>";
		exit;
	}
	$daemon_message = "";
    if (isset($_POST["meter"])) {
		$meter = intval(str_replace(",", ".", $_POST["meter"])*1000);
		$daemon_password = substr($_POST["password"], 0, 15);
		if (strlen($daemon_password)) {
			$daemon_message = "CALIBRATE $meter $daemon_password";
			#echo "<p>$daemon_message</p>\n";
		} else {
			echo "<p>Error, empty password!</p>\n";
		}
	} else {
		echo "<p>&nbsp;</p>\n";
	}

	if (!$socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP))  {
		echo "<p>Error, could not create socket!</b>\n";
		echo "</body>\n</html>";
		exit;
	}
	if (!$result = socket_connect($socket, $daemon_host, $daemon_port)) {
		echo "<p>Error, could not connect to daemon!</b>\n";
		echo "</body>\n</html>";
		exit;
	}
	if (strlen($daemon_message)) {
		socket_write($socket, $daemon_message, strlen($daemon_message));
	}

	$result = socket_read ($socket, 127, PHP_NORMAL_READ);
	$result .=socket_read ($socket, 127, PHP_NORMAL_READ);
	$result .=socket_read ($socket, 127, PHP_BINARY_READ);

	$result .=socket_read ($socket, 127, PHP_BINARY_READ);
	$result .=socket_read ($socket, 127, PHP_BINARY_READ);
	$result .=socket_read ($socket, 127, PHP_BINARY_READ);
	$result .=socket_read ($socket, 127, PHP_BINARY_READ);
	$result .=socket_read ($socket, 127, PHP_BINARY_READ);
	$result .=socket_read ($socket, 127, PHP_BINARY_READ);

	socket_close($socket);

	foreach(preg_split('~[\r\n]+~', $result) as $line){
		//  if(empty($line) or ctype_space($line)) continue; // skip only spaces
		//  if(!strlen($line = trim($line))) continue; // or trim by force and skip empty
		//  $line is trimmed and nice here so use it
		//	print "$line \n\n";
		list($source, $param, $value) = sscanf($line, "%s %s %f");
		if ($source == "HW" and $param == "Meter:") {
			$meter_value=$value;
		}
		if ($source == "DB" and $param == "Meter:" and !$meter_value) {
			$meter_value=$value;
		}
		//Wrong password or zero counter value.
		if ($source == "Wrong") {
			$response = "Error: wrong password or zero meter value, hardware not calibrated.";
		}
		//Calibrate to: 77260500 kWh
		if ($source == "Calibrate") {
			$response = "Hardware calibrated to $value kWh.";
		}
	}
	echo "<p>$response</p>\n";
	echo "<h2>Daemon status</h2>\n";
	echo "<table id='pre'><tr><td>\n";
	echo "<pre>\n$result</pre>\n";
	echo "</td></tr></table>\n";
?>


<form name='calibrate' method="POST" action="" enctype="multipart/form-data">
<table class="px20"><tr>
<td><b>New meter value:</b></td> 
<td><input class="textarea_digital" size="8" type="text" name="meter" value="<?php echo $meter_value; ?>" ></td>
<td>kWh</td>
<td><b>Password:</b><input type="password" name="password" size="12"></td>
<td><input type="submit" name="do_calibrate" value="Calibrate!"></td>
</tr></table>
</form>


<p>&nbsp</p>
<div class="right"><a href=".">Main index</a></div>
<hr>
<table style="width: 100%;"><tr>
<td>
<a href="http://validator.w3.org/check?uri=referer">
<img src="http://www.w3.org/Icons/valid-html401" alt="Valid HTML 4.01 Strict" height="31" width="88"></a>
</td><td style="text-align:right; vertical-align:top;">(c) Daniel Vindev&aring;g 2014</td></tr>
</table>

</body></html>

